#include "systemc.h"

class ModuleLeft: sc_module {
public:
  SC_HAS_PROCESS(ModuleLeft);

  sc_event &event_;

  ModuleLeft(sc_module_name mn, sc_event &event):
    sc_module(mn),
    event_(event)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    //std::cout << "ping left" << std::endl;
    event_.notify();
  }
};

class ModuleRight: sc_module {

public:
  SC_HAS_PROCESS(ModuleRight);

  sc_event &event_;
  int id_;

  ModuleRight(sc_module_name mn, sc_event &event, int id):
    sc_module(mn),
    event_(event),
    id_(id)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    //std::cout << "pong right " << id_ << std::endl;

    //wait(SC_ZERO_TIME);
    wait();

    //wait(SC_ZERO_TIME);
    wait();

    //wait(SC_ZERO_TIME);
    wait();

    //wait(SC_ZERO_TIME);
    wait();
  }
};

class Module: sc_module {

public:

  SC_HAS_PROCESS(Module);
  sc_event event;

  ModuleLeft left;
  ModuleRight right0;
  ModuleRight right1;
  ModuleRight right2;
  ModuleRight right3;
  ModuleRight right4;
  ModuleRight right5;
  int foo;

  Module(sc_module_name mn):
    sc_module(mn),
    left("left", event),
    right0("right0", event, 0),
    right1("right1", event, 1),
    right2("right2", event, 2),
    right3("right3", event, 3),
    right4("right4", event, 4),
    right5("right5", event, 5)
  {
  }
};


int sc_main(int argc, char **argv)
{
  Module m("m");
  sc_start();
  return 0;
}

