#include<iostream>
#include<string>
#include<assert.h>

#include "rose.h"
#include "risc.h"

using namespace SageBuilder;
using namespace SageInterface;

int main (int argc, char* argv[] )
{
  std::cout << std::endl
            << "START PROCESSING FILE: " __FILE__
            << " ..."
            << std::endl;

  SgProject* sagaProject = frontend(argc, argv);
  AstTests::runAllTests(sagaProject);


  SgClassDefinition* base =
    risc::tools::find_class_definition("Foo","::", isSgProject(sagaProject));

  SgClassDefinition* derived =
    risc::tools::find_class_definition("C","::", isSgProject(sagaProject));


  std::cout << "base " << base << std::endl;
  std::cout << "derived " << derived << std::endl;


  std::cout << risc::tools::is_derived_from(derived, base) << std::endl;

  // this should be 1
  // that means the class C is derived from Class Foo
  assert(risc::tools::is_derived_from(derived, base));



  std::cout << "END PROCESSING FILE: " __FILE__
            << " ..."
            << std::endl
            << std::endl;

  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
